Attribute VB_Name = "modBNLS"
Private m_Handle            As Long
Private m_Data              As String
Private m_Client            As Long

Public Sub ConnectBNLS()
    Form1.hSckBNLS.Close
    Form1.hSckBNLS.Connect modBNET.hBnBNLS, 9367&
End Sub

Public Sub OnBNLSConnect()
    m_Handle = Form1.hSckBNLS.SocketHandle
    m_Data = vbNullString
    Select Case modBNET.hBnClient
        Case CLIENT_RATS: m_Client = 1
        Case CLIENT_PXES: m_Client = 2
        Case CLIENT_NB2W: m_Client = 3
        Case CLIENT_VD2D: m_Client = 4
        Case CLIENT_PX2D: m_Client = 5
        Case CLIENT_RTSJ: m_Client = 6
        Case CLIENT_3RAW: m_Client = 7
        Case CLIENT_PX3W: m_Client = 8
        Case CLIENT_LTRD: m_Client = 9
        Case CLIENT_RHSD: m_Client = 10
        Case CLIENT_RHSS: m_Client = 11
        Case Else:        m_Client = 0
    End Select
    Call SL10
End Sub
Public Sub OnBNLSData(ByRef S As String)
    On Error GoTo OnBNLSDataErr
    Dim lngLengh        As Long
    m_Data = m_Data & S
    While (Len(m_Data) > 2)
        Call CopyMemory(lngLengh, ByVal Mid$(m_Data, 1, 2), 2)
        If (lngLengh > 1000) Then GoTo OnBNLSDataErr
        If (lngLengh > Len(m_Data)) Then Exit Sub
        S = Left$(m_Data, lngLengh)
        m_Data = Mid$(m_Data, 1 + lngLengh)
        Call Parse(S)
    Wend
    Exit Sub
OnBNLSDataErr:
    m_Data = vbNullString
End Sub
Public Sub OnBNLSError(Optional ByVal lngErrNumber As Long = -1, Optional ByVal strDescription As String = vbNullString)
    If (lngErrNumber = 0) Then
        sBNLS vbRed, "Connection Closed."
    Else
        sBNLS vbRed, "Error" & IIf((lngErrNumber = -1), ":", "(" & lngErrNumber & ")") & Space$(1) & strDescription
    End If
    Call modBNET.DisconnectBNET
End Sub


Private Sub Parse(ByRef S As String)
    Dim bID     As Byte
    bID = Asc(Mid$(S, 3, 1))
    If (bID = &H10) Then
        Call HL10(S)
    ElseIf (bID = &H1A) Then
        Call HL1A(S)
    End If
End Sub
Private Sub HL10(ByRef S As String)
    If (Len(S) < 7) Then Exit Sub
    Dim lngResult       As Long
    Call CopyMemory(lngResult, ByVal Mid$(S, 4, 4), 4)
    If ((lngResult = &H0&) Or (Len(S) < 11)) Then
        Call OnBNLSError(, "Get Version Byte Problem " & LngToHex(lngResult) & ", " & LngToHex(Len(S)))
        Exit Sub
    End If
    Call CopyMemory(lngResult, ByVal Mid$(S, 8, 4), 4)
    Call modBNET.OnBNETVByte(lngResult)
End Sub
Private Sub HL1A(ByRef S As String)
    If (Len(S) < 11) Then Exit Sub
    Form1.hSckBNLS.Close
    Dim lngResult       As Long
    Dim lngChecksum     As Long
    Call CopyMemory(lngResult, ByVal Mid$(S, 4, 4), 4)
    If ((lngResult = &H0&) Or (Len(S) < 24)) Then
        Call OnBNLSError(, "Checkrevision Problem " & LngToHex(lngResult) & ", " & LngToHex(Len(S)))
        Exit Sub
    End If
    Call CopyMemory(lngResult, ByVal Mid$(S, 8, 4), 4)
    Call CopyMemory(lngChecksum, ByVal Mid$(S, 12, 4), 4)
    '(DWORD)    Cookie
    '(DWORD)    Versionbyte
    Call modBNET.OnBNETCR(lngResult, lngChecksum, GetSTRING(Mid$(S, 16)))
End Sub

Private Sub SL10()
    Call iClear
    Call iDWORD(m_Client)
    Call iHEADER(&H10, BNLS_HEADER)
    Call iPacket(m_Handle)
End Sub
Public Sub SL1A(ByRef udtFileTime As FILETIMESTRUT, _
                ByVal strFileName As String, _
                ByVal strFormula As String)
    Call iClear
    Call iDWORD(m_Client)
    Call iDWORD(&H0&)
    Call iDWORD(GetTickCount())
    Call iFILETIME(udtFileTime)
    Call iNTSTRING(strFileName)
    Call iNTSTRING(strFormula)
    Call iHEADER(&H1A, BNLS_HEADER)
    Call iPacket(m_Handle)
End Sub

Private Sub sBNLS(ByVal lngColor As Long, ByVal strText As String)
    Call modCtrl.sChat(&HC0C000, "[BNLS] ")
    Call modCtrl.aChat(lngColor, strText)
End Sub

